* Qlib's PIPE toolkit
*
* V3.36,  Liberation Software, 1993
* V3.42, PW, 2021 Aug 08
*

        section pipe

        filetype 0

        include dev8_keys_qlv
        include dev8_keys_err

        lea     key,a1
        movea.w sb.inipr,a2
        jmp     (a2)
* 

key     dc.w    1
        dc.w    pipe-*
        dc.b    6,'Q_PIPE '
        dc.w    0,0,0

*
L0080   movea.l $0030(a6),a0
        moveq   #$28,d0
        mulu.w  $00(a6,a1.l),d0
        addq.w  #$02,a1
        adda.l  d0,a0
        rts
* 

pipe    movea.w sb.gtint,a2
        jsr     (a2)
          bne.s exit
        move.b  d3,d4
          beq.s err_bp
        bsr.s   L0080
        move.l  $00(a6,a0.l),d3
          bmi.s err_ch
        subq.b  #$02,d4
          blt.s L00B6
          bne.s err_bp
        move.w  -$02(a6,a1.l),d1
        cmp.w   $00(a6,a1.l),d1
          ble.s err_bp
        bsr.s   L0080

L00B6   movea.l a0,a4
        lea     name,a0
        moveq   #-$01,d1
        moveq   #$01,d0         ; IO_OPEN
        trap    #$02
        tst.l   d0
          bne.s exit
        move.l  a0,$00(a6,a4.l)
exit    rts

*
err_bp  moveq   #err.ipar,d0
        rts
* 
err_ch  moveq   #err.ichn,d0
        rts

*
name    dc.w 4,'PIPE'

*
        end
